package com.example.gajz.redis;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

/**
 * redis连接池
 * @author lenovo
 */
public class ConFigRedis {

    private static JedisPool pool = null;
    /**
     * 获取jedis连接池
     * */
    public static JedisPool getPool(){
        if(pool == null){
            //创建jedis连接池配置
            JedisPoolConfig config = new JedisPoolConfig();
            //最大连接数
            config.setMaxTotal(100);
            //最大空闲连接
            config.setMaxIdle(20);
            //创建redis连接池
            /**服务器*/
//            pool = new JedisPool(config,"127.0.0.1",6379,30000,"1qaz2wsx3edc");
            /**本地*/
            pool = new JedisPool(config,"127.0.0.1",6379,30000);
        }
        return pool;
    }
    /**
     * 获取jedis连接
     * */
    public static Jedis getConn()
    {
        return getPool().getResource();
    }

}
