package com.example.gajz.transferrelationship.bean.excel;
import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;
import lombok.ToString;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.time.DateTimeException;
import java.util.Date;

/**
 * 转账关系图Excel封装类
 */
@Data
@ToString
public class abcExcie {

    /**
     * 主键
     */
    @ExcelProperty(value = "id",index = 0)
    private int id;

    /**
     * 身份证号
     */
    @ExcelProperty(value = "id_card",index = 1)
    private String id_card;

    /**
     * 手机号
     */
    @ExcelProperty(value = "mobile",index = 2)
    private String mobile;

    /**
     * 本端账户名
     */
    @ExcelProperty(value = "bank_account_name",index = 3)
    private String bank_account_name;

    /**
     * 本端账号
     */
    @ExcelProperty(value = "bank_account_no",index = 4)
    private String bank_account_no;

    /**
     * 本端卡号
     */
    @ExcelProperty(value = "bank_card_no",index = 5)
    private String bank_card_no;

    /**
     * 曾用卡号
     */
    @ExcelProperty(value = "temp_a",index = 6)
    private String temp_a;

    /**
     * 本端账户开户行
     */
    @ExcelProperty(value = "bank_name",index = 7)
    private String bank_name;

    /**
     * 是否属资金池,0是1否
     */
    @ExcelProperty(value = "is_capital_pool",index = 8)
    private int is_capital_pool;

    /**
     * 交易时间
     */
    @ExcelProperty(value = "trade_date",index = 9)
    private String trade_date;

    /**
     * 记账时间
     */
    @ExcelProperty(value = "trade_time",index = 10)
    private String trade_time;

    /**
     * 收付标志，0收1支
     */
    @ExcelProperty(value = "payment_mark",index = 11)
    private int payment_mark;

    /**
     * 借方发生额（支出）
     */
    @ExcelProperty(value = "temp_c",index = 12)
    private BigDecimal temp_c;

    /**
     * 贷方发生额（收入）
     */
    @ExcelProperty(value = "temp_d",index = 13)
    private BigDecimal temp_d;

    /**
     * 交易金额
     */
    @ExcelProperty(value = "pay_amount",index = 14)
    private BigDecimal pay_amount;

    /**
     * 余额
     */
    @ExcelProperty(value = "balance",index = 15)
    private BigDecimal balance;

    /**
     * 目的、用途
     */
    @ExcelProperty(value = "purpose",index = 16)
    private int purpose;

    /**
     * 分红性质类别
     */
    @ExcelProperty(value = "bonus",index = 17)
    private int bonus;

    /**
     * 其他交易性质
     */
    @ExcelProperty(value = "trade_nature",index = 18)
    private int trade_nature;

    /**
     * 审计备注列1
     */
    @ExcelProperty(value = "temp_f",index = 19)
    private String temp_f;

    /**
     * 审计备注列2
     */
    @ExcelProperty(value = "temp_g",index = 20)
    private String temp_g;

    /**
     * 对端户名
     */
    @ExcelProperty(value = "end_account_name",index = 21)
    private String end_account_name;

    /**
     * 对端卡号
     */
    @ExcelProperty(value = "end_card_no",index = 22)
    private String end_card_no;

    /**
     * 对端开户行
     */
    @ExcelProperty(value = "end_bank_name",index = 23)
    private String end_bank_name;

    /**
     * 交易摘要
     */
    @ExcelProperty(value = "remark",index = 24)
    private String remark;

    /**
     * 交易备注
     */
    @ExcelProperty(value = "comment",index = 25)
    private String comment;

    /**
     * 交易场所
     */
    @ExcelProperty(value = "treade_place",index = 26)
    private String treade_place;




}
