package com.example.gajz.transferrelationship.dao;
import com.example.gajz.transferrelationship.bean.excel.abcExcie;
import com.example.gajz.transferrelationship.bean.param.data;
import com.example.gajz.transferrelationship.bean.vo.CenterPointVo;
import com.example.gajz.transferrelationship.bean.vo.SearchRelationshipVo;
import com.example.gajz.transferrelationship.bean.vo.TransferCardVo;
import com.example.gajz.transferrelationship.bean.vo.personalTransferRelationshipVo;
import org.apache.ibatis.annotations.Mapper;
import java.util.List;

/**
 * @author lenovo
 */
@Mapper
public interface TransferRelationshipMapper {

    /**
     * 查询全部转账卡号方法
     * @return
     */
    List<TransferCardVo> selectTransferCard();

    /**
     * 转账关系
     * @return
     */
    List<com.example.gajz.transferrelationship.bean.param.data> edge();


    /**
     * 查询被转账人全部信息
     * @return
     * @param bankCardNo
     */
    List<com.example.gajz.transferrelationship.bean.param.data> transferRelationship(String bankCardNo);

    /**
     * 查询转账记录
     * @param cardNumber
     * @param fullName
     */
    List<SearchRelationshipVo> transferRecord(String cardNumber, String fullName);

    /**
     * 查询搜索人被转账记录
     * @param cardNumber
     * @param fullName
     * @return
     */
    List<SearchRelationshipVo> transferredRecord(String cardNumber, String fullName);

    /**
     * 查询搜索人信息   转账人
     * @param cardnumbe
     * @return
     */
    List<SearchRelationshipVo> personalInformationTransferor(String cardnumbe);

    /**
     * 查询搜索人信息   被转账人
     * @param cardnumbe
     * @return
     */
    List<SearchRelationshipVo> personalInformationTransferredPerson(String cardnumbe);

    /**
     * 清空关系图数据表
     */
    void emptyTransferRelationship();

    /**
     * excel数据导入数据库
     * @param eSerialsList
     */
    void insertTransferRelationship(List<abcExcie> eSerialsList);

    /**
     *查询搜索人关联下一级数据
     * @param cardNumber
     * @return
     */
    List<SearchRelationshipVo> querySubordinate(String cardNumber);

    /**
     * 查询转账人
     * @param cardNumber
     * @param fullName
     * @return
     */
    List<SearchRelationshipVo> queryTransferor(String cardNumber, String fullName);

    /**
     * 查询被转账人
     * @param cardNumber
     * @param fullName
     * @return
     */
    List<SearchRelationshipVo> queryTheTransferredPerson(String cardNumber, String fullName);


    /**
     * 查询单人转账关系
     * @param cardnumbe
     */
    List<personalTransferRelationshipVo> personalTransferRelationship(String cardnumbe);

    /**
     * 查询上级转账人方法
     * @param cardNumbe
     * @return
     */
    List<SearchRelationshipVo> querySuperior(String cardNumbe);

    /**
     * 查询两人转账关系  关系  (关系图) 接口
     * @param cardNumber
     * @return
     */
    List<personalTransferRelationshipVo> trBetweenTwoPersons(String cardNumber);



    /**
     * 查询中心点下级中心点
     * @param transferCardVoList
     * @return
     */
    List<CenterPointVo> centerPointMethod(List<TransferCardVo> transferCardVoList, String bankCardNo);

    /**
     * 查询共有多少点  根据点的数量决定生成随机范围大小
     * @return
     */
    List<com.example.gajz.transferrelationship.bean.param.data> selectNumberPoints();

    /**
     * 查询拥有多人转账关系的点
     * @return
     */
    List<TransferCardVo> selectmanyPeople();

    /**
     * 查询与中心点所有相关联的点
     * @param bankCardNo
     * @return
     */
    List<data> correlationPoint(String bankCardNo);

    /**
     * 查询被转账人 多人转账关系数据方法
     * @param bankCardNo
     * @return
     */
    List<TransferCardVo> selectmanyPeoples(String bankCardNo);
}
