package com.example.gajz.transferrelationship.relationalalgorithm;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.example.gajz.redis.ConFigRedis;
import com.example.gajz.transferrelationship.bean.vo.Test;
import com.example.gajz.transferrelationship.bean.vo.TransferCardVo;
import com.example.gajz.transferrelationship.config.Colour;
import com.example.gajz.transferrelationship.dao.TransferRelationshipMapper;
import org.springframework.stereotype.Component;
import redis.clients.jedis.Jedis;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 关系图 - 分散图形算法工具类
 */
@Component
public class DispersionDiagram {

    /**关系图数据持久层*/
    @Resource
    TransferRelationshipMapper transferRelationshipMapper;

    public static DispersionDiagram test;

    @PostConstruct
    public void init(){
        test= this;
        test.transferRelationshipMapper=transferRelationshipMapper;
    }

    /**
     * 分散图形算法
     * @param numerical
     */
    public List dispersionDiagram(String numerical){
        /**最终返回值list*/
        List list=new ArrayList();
        /**查询点数有多少*/
        List<com.example.gajz.transferrelationship.bean.param.data> dataList1 = transferRelationshipMapper.selectNumberPoints();
        /**开启Redis连接*/
        Jedis conn = ConFigRedis.getConn();
        String time = conn.get("TimeQuantity");
        /**
         * 判断数据库里面的点数是否有变动   如果有变动就重新生成图形
         * 并且清空Redis数据库数据  重新放入新的生成后数据
         */
        if (time!=null&&"null".equals(numerical)){
            //如果数量相等代表数据库没有变动  就从Redis里面获取数据
            if (Integer.parseInt(time) == dataList1.size()){
                String listQuantity = conn.get("ListQuantity");
                List<Test> dataArr = JSON.parseArray(listQuantity,Test.class);
                for (Test test: dataArr){
                    list.add(test);
                }
                conn.close();
                return list;
            }
        }
        //Redis存储圆点数量
        conn.set("TimeQuantity", String.valueOf(dataList1.size()));
        /**已经存在的点 会存储到map里面*/
        HashMap hashMap=new HashMap();
        //查询转账人(中心点)信息
        List<TransferCardVo> transferCardVos = transferRelationshipMapper.selectTransferCard();
        /**------------------------------------查询共有多少点  根据点的数量决定生成随机范围大小--------------------------------*/
        double range=Math.ceil(dataList1.size()/50000.00);
        double numberRanges = range*5000;
        /**------------------------------------查询共有多少点  根据点的数量决定生成随机范围大小--------------------------------*/
        /**----------------------------------计算中心点位置 开始------------------------------------*/
        /**计算中心点方法*/
//        List<CenterPointVo> centerPointVoList = calculationCenterPoint.CenterPointMethod(transferCardVos);
        /**----------------------------------计算中心点位置 结束------------------------------------*/
        /**---------------------------------查询拥有多人转账关系的点 开始--------------------------------*/
//        List<TransferCardVo> transferCardVos1 = transferRelationshipMapper.selectmanyPeople();
//        for (int i=0;i<transferCardVos1.size();i++){
////            //生成颜色
////            Colour colour=new Colour();
////            String code=colour.getColour();
////            Test test=new Test();
////            test.setId(transferCardVos1.get(i).getBankCardNo());
////            test.setName(transferCardVos1.get(i).getName());
////            test.setColor(code);
////            test.setSize(7);
////            test.setX((float)(Math.random()*numberRanges));
////            test.setY((float)(Math.random()*numberRanges));
////            list.add(test);
////        }
        /**---------------------------------查询拥有多人转账关系的点 结束--------------------------------*/

        double centerPointX = 0;
        double centerPointY = 0;
        //存储所有大圆的四角X Y轴数据
        HashMap xyMap = new HashMap();
        /** 中心点*/
        for (int i=0;i<transferCardVos.size();i++){
            //存储已经生成的点
            hashMap.put(transferCardVos.get(i).getBankCardNo(),"1");
            //是否重叠
//            boolean overlap=false;
            //生成颜色
            Colour colour=new Colour();
            String code=colour.getColour();
            Test test=new Test();
            test.setId(transferCardVos.get(i).getBankCardNo());
            test.setX((float)(Math.random()*numberRanges));
            test.setY((float)(Math.random()*numberRanges));
            test.setName(transferCardVos.get(i).getName());
            test.setColor(code);
//            centerPointX=test.getX();
//            centerPointY=test.getY();
            //查询被转账人 多人转账关系数据方法
            List<TransferCardVo> transferCardVos1 =transferRelationshipMapper.selectmanyPeoples(transferCardVos.get(i).getBankCardNo());
            /** -----------------------------------------------------------------------------------------*/
            //范围最小值
            int minimum = 0;
            //范围最大值
            int maximum = 0;
            if (transferCardVos1.size()==0||transferCardVos1.size()<=50){
                test.setSize(10);
                minimum=100;
                maximum=200;
            }else if (transferCardVos1.size()>50&&transferCardVos1.size()<=100){
                test.setSize(15);
                minimum=300;
                maximum=300;
            }else if (transferCardVos1.size()>100&&transferCardVos1.size()<=200){
                test.setSize(20);
                minimum=300;
                maximum=450;
            }else if (transferCardVos1.size()>200){
                test.setSize(25);
                minimum=300;
                maximum=500;
            }
            list.add(test);
            /**生成只跟中心点有关系的数据  合并成一个点*/
            /**查询被转账人全部信息*/
            List<com.example.gajz.transferrelationship.bean.param.data> transfer = transferRelationshipMapper.transferRelationship(transferCardVos.get(i).getBankCardNo());
            if (transfer.size()!=0){
                Test testg=new Test();
                testg.setSize(20);
                testg.setX((int) ((test.getX()-minimum)+Math.random()*((test.getX()+maximum)-(test.getX()-minimum)+1)));
                testg.setY((int) ((test.getY()-minimum)+Math.random()*((test.getY()+maximum)-(test.getY()-minimum)+1)));
                testg.setColor(code);
                testg.setId(transfer.get(0).getTarget());
                testg.setName("单人转账关系总人数:"+transfer.size());
                list.add(testg);
            }
         for (int n=0;n<transferCardVos1.size();n++){
             Object isNot = hashMap.get(transferCardVos1.get(n).getBankCardNo());
             if (isNot==null){
                 Test tests=new Test();
                 tests.setId(transferCardVos1.get(n).getBankCardNo());
                 tests.setName(transferCardVos1.get(n).getName());
                 tests.setColor(code);
                 tests.setSize(10);
                 tests.setX((int) ((test.getX()-minimum)+Math.random()*((test.getX()+maximum)-(test.getX()-minimum)+1)));
                 tests.setY((int) ((test.getY()-minimum)+Math.random()*((test.getY()+maximum)-(test.getY()-minimum)+1)));
                 list.add(tests);
                 hashMap.put(transferCardVos1.get(n).getBankCardNo(),"1");
             }
        }
            /**  -----------------------计算大图四个角的XY轴代码-----------------------*/
//            /**算大圈半径专用    总数*/
//            int bigTotal = transfer.size();
//
//            /**算大圈半径专用   每圈点数*/
//            int bigBase = 20;
//            for (int n=1;bigTotal>0;n++){
//                bigTotal = bigTotal-bigBase;
//                bigBase = bigBase+50;
//            }
//            /** 大圆最后一圈半径  每份多少点数 */
//            int bigPointsPerShare = bigBase/4;
//            /**大圆最后一圈半径   相等于大圈半径   点数*距离 */
//            int fullCircleRadius =bigPointsPerShare*2;
            /**  -------------------------------------------------------------------*/
//            if (i==0){
//                xyMap.put(i+"zX",(centerPointX-fullCircleRadius)); //圆左X轴
//                xyMap.put(i+"zY",centerPointY); //圆左Y轴
//                xyMap.put(i+"yX",(centerPointX+fullCircleRadius)); //圆右X轴
//                xyMap.put(i+"yY",centerPointY); //圆右Y轴
//                xyMap.put(i+"sX",centerPointX); //圆上X轴
//                xyMap.put(i+"sY",(centerPointY-fullCircleRadius)); //圆上Y轴
//                xyMap.put(i+"xX",centerPointX); //圆下X轴
//                xyMap.put(i+"xY",(centerPointY+fullCircleRadius)); //圆下Y轴
//                list.add(test);
//                overlap=true;
//            }else {
//                for (int p=0;p<i;p++){
//                    double zX = (double) xyMap.get(p + "zX");
//                    double yX = (double) xyMap.get(p + "yX");
//                    double sY = (double) xyMap.get(p + "sY");
//                    double xY = (double) xyMap.get(p + "xY");
//                    if(((zX>(centerPointX-fullCircleRadius)&&zX>(centerPointX+fullCircleRadius)) ||(yX<(centerPointX-fullCircleRadius)&&yX<(centerPointX+fullCircleRadius)))
//                            ||
//                            ((sY>(centerPointY-fullCircleRadius)&&sY>(centerPointY+fullCircleRadius)) ||(xY<(centerPointY-fullCircleRadius)&&xY<(centerPointY+fullCircleRadius)))){
//                        if (p==i-1) {
//                            xyMap.put(i + "zX", (centerPointX-fullCircleRadius)); //圆左X轴
//                            xyMap.put(i + "zY", centerPointY); //圆左Y轴
//                            xyMap.put(i + "yX", (centerPointX+fullCircleRadius)); //圆右X轴
//                            xyMap.put(i + "yY", centerPointY); //圆右Y轴
//                            xyMap.put(i + "sX", centerPointX); //圆上X轴
//                            xyMap.put(i + "sY", (centerPointY-fullCircleRadius)); //圆上Y轴
//                            xyMap.put(i + "xX", centerPointX); //圆下X轴
//                            xyMap.put(i + "xY", (centerPointY+fullCircleRadius)); //圆下Y轴
//                            /** 将中心点X Y轴拼接 并存入Redis中*/
////                            String position=test.getX()+"Y"+test.getY();
////                            conn.set(test.getId(),position);
//                            list.add(test);
//                            overlap=true;
//                        }
//                    }else {
//                        //设置已经碰撞
//                        overlap=false;
//                        break;
//                    }
//                }
//            }
//            if (!overlap){
//                i--;
//                continue;
//            }
//            /**将没有重复的值 存储到这个list里面*/
//            List<com.example.gajz.transferrelationship.bean.param.data> dataList=new ArrayList<>();
//            /**循环下级数据  将下级数据存入list中*/
//            for (int p=0;p<transfer.size();p++){
//                    Object targets = hashMap.get(transfer.get(p).getTarget());
//                    if (targets==null) {
//                        com.example.gajz.transferrelationship.bean.param.data data = new com.example.gajz.transferrelationship.bean.param.data();
//                        data.setName(transfer.get(p).getName());
//                        data.setTarget(transfer.get(p).getTarget());
//                        data.setTransferTimes(transfer.get(p).getTransferTimes());
//                        dataList.add(data);
//                        hashMap.put(transfer.get(p).getTarget(), transfer.get(p).getTarget());
//                    }
//            }
//            /**循环次数*/
//            int numberCycles =0;
//            /**每圈点数  动态变化 */
//            int base = 40;
//            /**总数*/
//            int total = dataList.size();
//            /**圆圈层数  每循环一次 就是一圈*/
//            for (int y=1;total>0;y++){
//                /**圆分成四份  每份多少点数*/
//                float pointsPerShare = base;
//                /**每份点数 / 90度  算出每个点数的度数*/
//                double eachDegree=360/pointsPerShare;
//                /**小圆半径  点数X距离*/
//                double circleRadius=15*y;
//                /**点大小*/
//                double pointSize =2;
//                if (base<=total){
//                    for (int t=0;t<base;t++){
//                        Test test1=new Test();
//                        //算出A角度数   （每份点数-t）* 每点度数
//                        double Adegrees = (double) ((pointsPerShare-t) * eachDegree);
//                        //Y轴
//                        double Y= (double) (circleRadius*Math.cos(Adegrees));
//                        //X轴
//                        double X= (double) (circleRadius*Math.sin(Adegrees));
//                        test1.setId(dataList.get(numberCycles).getTarget());
//                        test1.setName(dataList.get(numberCycles).getName());
//                        test1.setX(centerPointX+X);
//                        test1.setY(centerPointY-Y);
//                        test1.setColor(code);
//                        test1.setSize(pointSize);
////                        list.add(test1);
//                        numberCycles++;
//                    }
//                    total=total-base;
//                    base = base+(40);
//                    continue;
//                }
//                if (base>0){
//                    /**每份点数 / 90度  算出每个点数的度数*/
//                    double eachDegrees=360    /pointsPerShare;
//                    for (int t=0;numberCycles<dataList.size();t++){
//                        Test test1=new Test();
//                            //算出A角度数   （每份点数-t）* 每点度数
//                            double Adegrees = (double) ((pointsPerShare-t) * eachDegrees);
//                            //Y轴
//                            double Y= (double) (circleRadius*Math.sin(Adegrees));
//                            //X轴
//                            double X= (double) (circleRadius*Math.cos(Adegrees));
//                            test1.setId(dataList.get(numberCycles).getTarget());
//                            test1.setName(dataList.get(numberCycles).getName());
//                            test1.setX(centerPointX+Y);
//                            test1.setY(centerPointY-X);
//                            test1.setColor(code);
//                            test1.setSize(pointSize);
////                        list.add(test1);
//                        numberCycles++;
//                    }
//                    break;
//                }
//            }
        }
        /**Reids存储最新圆点数据*/
        conn.set("ListQuantity", JSONArray.toJSONString(list));
        conn.close();
        return list;
    }
}
