package com.example.gajz.transferrelationship.relationalalgorithm;

import com.example.gajz.transferrelationship.bean.param.data;
import com.example.gajz.transferrelationship.dao.TransferRelationshipMapper;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 算大图四个角的XY轴 工具类
 */
@Component
public class LocationCalculation {


    /**关系图数据持久层*/
    @Resource
    TransferRelationshipMapper transferRelationshipMapper;

    public static LocationCalculation test;

    @PostConstruct
    public void init(){
        test= this;
        test.transferRelationshipMapper=transferRelationshipMapper;
    }

    /**
     * 算大图四个角的XY轴 方法
     */
    public HashMap LocationCalculationMethod(String bankCardNo,int X,int Y){

        /**存储大圆的四角X Y轴数据*/
        HashMap xyMap = new HashMap();
        /**查询被转账人（下级）全部信息*/
        List<data> transfer = transferRelationshipMapper.transferRelationship(bankCardNo);
        /**下级数据存放list*/
        List<com.example.gajz.transferrelationship.bean.param.data> dataList=new ArrayList<>();
        for (int i=0;i<transfer.size();i++){
            com.example.gajz.transferrelationship.bean.param.data data=new com.example.gajz.transferrelationship.bean.param.data();
            data.setName(transfer.get(i).getName());
            dataList.add(data);
        }
        /**算大圈半径专用  下级数量总数*/
        int bigTotal = dataList.size();
        /**算大圈半径专用   每圈点数*/
        int bigBase = 8;
        for (int n=1;bigTotal>0;n++){
            bigTotal = bigTotal-bigBase;
            bigBase = bigBase+20;
        }
        /** 大圆最后一圈半径  每份多少点数 */
        int bigPointsPerShare = bigBase/4;
        /**大圆最后一圈半径   相等于大圈半径   点数*距离 */
        int fullCircleRadius =bigPointsPerShare*2;
        xyMap.put("zx",(X-fullCircleRadius)); //圆左X轴
        xyMap.put("zy",Y); //圆左Y轴
        xyMap.put("yx",(X+fullCircleRadius)); //圆右X轴
        xyMap.put("yy",Y); //圆右Y轴
        xyMap.put("sx",X); //圆上X轴
        xyMap.put("sy",(Y-fullCircleRadius)); //圆上Y轴
        xyMap.put("xx",X); //圆下X轴
        xyMap.put("xy",(Y+fullCircleRadius)); //圆下Y轴
        return xyMap;
    }
}
