package com.example.gajz.transferrelationship.relationalalgorithm;
import com.example.gajz.transferrelationship.bean.vo.SearchRelationshipVo;
import com.example.gajz.transferrelationship.dao.TransferRelationshipMapper;
import org.springframework.stereotype.Component;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 双人转账关系图  位置生成类
 */
@Component
public class TransferLocation {

    @Resource
    TransferRelationshipMapper transferRelationshipMapper;


    public static TransferLocation test;

    @PostConstruct
    public void init(){
        test= this;
        test.transferRelationshipMapper=transferRelationshipMapper;
    }
    /**
     * 双人转账关系  位置生成方法
     * @param transferAssociationList
     * @return
     */
    public List<SearchRelationshipVo> transferLocation(List<SearchRelationshipVo> transferAssociationList){
        /**-----------------------------------层级排序----------------------------------------*/
        List<SearchRelationshipVo> searchRelationshipVoList=new ArrayList<>();
        int Hierarchy=1;
        for (int k=0;k<1;){
            int m=0;
            for (int f=0;f<transferAssociationList.size();f++){
                if (transferAssociationList.get(f).getHierarchy()==Hierarchy){
                    searchRelationshipVoList.add(transferAssociationList.get(f));
                    m++;
                }
            }
            if (m==0){
                break;
            }
            Hierarchy++;
        }
        /**-----------------------------------层级排序----------------------------------------*/
        /**
         * 最终返回数据list
         */
        List<SearchRelationshipVo> searList=new ArrayList<>();
        /**
         * 将已经查询到的下级数据存入map中  防止重复
         */
        HashMap hashMap=new HashMap();
        //查询下级
        for (int i=0;i<searchRelationshipVoList.size();i++){
            /**
             * 存放下级参数list
             */
            List<SearchRelationshipVo> parameterList=new ArrayList<>();
            /**获取中心点  (上一级)*/
            String cardNumber = searchRelationshipVoList.get(i).getCardNumber();
            hashMap.put(cardNumber, cardNumber);
            /** 查询下级数据*/
            List<SearchRelationshipVo> querySubordinateList = test.transferRelationshipMapper.querySubordinate(cardNumber);
            /**循环做对比   查找出下级数据*/
            for (int n=0;n<querySubordinateList.size();n++){
                for (int p=0;p<searchRelationshipVoList.size();p++){
                    Object CardNumber = hashMap.get(searchRelationshipVoList.get(p).getCardNumber());
                    if (CardNumber==null) {
                        if (querySubordinateList.get(n).getCardNumber().equals(searchRelationshipVoList.get(p).getCardNumber())) {
                            /** 存放下级数据封装类*/
                            SearchRelationshipVo searchRelationshipVo=new SearchRelationshipVo();
                            searchRelationshipVo.setCardNumber(searchRelationshipVoList.get(p).getCardNumber());
                            searchRelationshipVo.setColor(searchRelationshipVoList.get(p).getColor());
                            searchRelationshipVo.setSize(searchRelationshipVoList.get(p).getSize());
                            searchRelationshipVo.setName(searchRelationshipVoList.get(p).getName());
                            searchRelationshipVo.setHierarchy(searchRelationshipVoList.get(p).getHierarchy());
                            //将已经查询到的下级存入map中  下次循环做对比  防止重复
                            hashMap.put(searchRelationshipVoList.get(p).getCardNumber(), searchRelationshipVoList.get(p).getCardNumber());
                            parameterList.add(searchRelationshipVo);
                        }
                    }
                }
            }
            /**每圈点数  动态变化 */
            int base = 8;
            /**总数*/
            int total = parameterList.size();
            //判断上级卡号是否是转账人  如果是就设置初始xy轴
            if (searchRelationshipVoList.get(i).getHierarchy()==1){
                searchRelationshipVoList.get(i).setY(300);
                searchRelationshipVoList.get(i).setX(300);
                searList.add(searchRelationshipVoList.get(i));
                double centerPointX=searchRelationshipVoList.get(i).getX();
                double centerPointY=searchRelationshipVoList.get(i).getY();
                /**循环次数*/
                int numberCycles =0;
                /**循环下级点数   计算下级X Y轴位置*/
                for (int y=1;total>0;y++){
                    /**点之间 x轴y轴间隔距离*/
                    int distance=100;
                    /**圆分成两份 */
                    int pointsPerShare = base/2;
                    /**小圆半径  */
                    int circleRadius = 300;
                    /**X逐渐递增*/
                    int lowerRight = 0;
                    /**Y逐渐递增*/
                    int lowerRightY= 0;
                    if (base<=total){
                        for (int t=0;t<base;t++){
                            SearchRelationshipVo searchRelationship=new SearchRelationshipVo();
                            if (t<pointsPerShare){
                                if(t%2==0){
                                    searchRelationship.setX(centerPointX+circleRadius+50);
                                }else {
                                    searchRelationship.setX(centerPointX+circleRadius);
                                }
                                searchRelationship.setY(centerPointY-(distance*lowerRight));
                                searchRelationship.setName(parameterList.get(numberCycles).getName());
                                searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                searList.add(searchRelationship);
                                lowerRight++;
                            }else if (t<=pointsPerShare*2){
                                if(t%2==0){
                                    searchRelationship.setX(centerPointX+circleRadius+50);
                                }else {
                                    searchRelationship.setX(centerPointX+circleRadius);
                                }
                                searchRelationship.setY(centerPointY+(lowerRightY*distance));
                                searchRelationship.setName(parameterList.get(numberCycles).getName());
                                searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                searList.add(searchRelationship);
                                lowerRightY++;
                            }
                            numberCycles++;
                        }
                        total=total-base;
                        base = base+20;
                        continue;
                    }
                    if (base>0){
                        for (int t=0;numberCycles<parameterList.size();t++){
                            SearchRelationshipVo searchRelationship=new SearchRelationshipVo();
                            if (t<pointsPerShare){
                                if(t%2==0){
                                    searchRelationship.setX(centerPointX+circleRadius+50);
                                }else {
                                    searchRelationship.setX(centerPointX+circleRadius);
                                }
                                searchRelationship.setY(centerPointY-(lowerRight*distance));
                                searchRelationship.setName(parameterList.get(numberCycles).getName());
                                searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                lowerRight++;
                            }else if (t<=pointsPerShare*2){
                                if(t%2==0){
                                    searchRelationship.setX(centerPointX+circleRadius+50);
                                }else {
                                    searchRelationship.setX(centerPointX+circleRadius);
                                }
                                searchRelationship.setY(centerPointY+(lowerRightY*distance));
                                searchRelationship.setName(parameterList.get(numberCycles).getName());
                                searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                searList.add(searchRelationship);
                                lowerRightY++;
                            }
                            searList.add(searchRelationship);
                            numberCycles++;
                        }
                        break;
                    }
                }
            }else {
                /**循环返回值封装类   对比下一级卡号  获取X  Y轴*/
                for (int f=0;f<searList.size();f++){
                    /**中心点对比已经存储好的返回值  获取X Y轴*/
                    if (cardNumber.equals(searList.get(f).getCardNumber())){
                        double centerPointX = searList.get(f).getX();
                        double centerPointY = searList.get(f).getY();
                        /**循环次数*/
                        int numberCycles =0;
                        /**循环下级点数   计算下级X Y轴位置*/
                        for (int y=1;total>0;y++){
                            /**点之间 x轴y轴间隔距离*/
                            int distance=100;
                            /**圆分成两份 */
                            int pointsPerShare = base/2;
                            /**半径*/
                            int circleRadius = 300;
                            /**右下角逐渐递减*/
                            int lowerRight = 1;
                            /**Y逐渐递增*/
                            int lowerRightY= 1;
                            if (base<=total){
                                for (int t=0;t<base;t++){
                                    SearchRelationshipVo searchRelationship=new SearchRelationshipVo();
                                    if (t<pointsPerShare){
                                        if(t%2==0){
                                            searchRelationship.setX(centerPointX+circleRadius+50);
                                        }else {
                                            searchRelationship.setX(centerPointX+circleRadius);
                                        }
                                        searchRelationship.setY(centerPointY-(lowerRight*distance));
                                        searchRelationship.setName(parameterList.get(numberCycles).getName());
                                        searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                        searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                        searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                        searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                        searList.add(searchRelationship);
                                        lowerRight++;
                                    }else if (t<=pointsPerShare*2){
                                        if(t%2==0){
                                            searchRelationship.setX(centerPointX+circleRadius+50);
                                        }else {
                                            searchRelationship.setX(centerPointX+circleRadius);
                                        }
                                        searchRelationship.setY(centerPointY+(lowerRightY*distance));
                                        searchRelationship.setName(parameterList.get(numberCycles).getName());
                                        searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                        searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                        searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                        searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                        searList.add(searchRelationship);
                                        lowerRightY++;
                                    }
                                    numberCycles++;
                                }
                                total=total-base;
                                base = base+20;
                                continue;
                            }
                            if (base>0){
                                for (int t=0;numberCycles<parameterList.size();t++){
                                    SearchRelationshipVo searchRelationship=new SearchRelationshipVo();
                                    if (t<pointsPerShare){
                                        if(t%2==0){
                                            searchRelationship.setX(centerPointX+circleRadius+50);
                                        }else {
                                            searchRelationship.setX(centerPointX+circleRadius);
                                        }
                                        searchRelationship.setY(centerPointY-(lowerRight*distance));
                                        searchRelationship.setName(parameterList.get(numberCycles).getName());
                                        searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                        searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                        searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                        searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                        lowerRight++;
                                    }else if (t<=pointsPerShare*2){
                                        if(t%2==0){
                                            searchRelationship.setX(centerPointX+circleRadius+50);
                                        }else {
                                            searchRelationship.setX(centerPointX+circleRadius);
                                        }
                                        searchRelationship.setY(centerPointY+(lowerRightY*distance));
                                        searchRelationship.setName(parameterList.get(numberCycles).getName());
                                        searchRelationship.setColor(parameterList.get(numberCycles).getColor());
                                        searchRelationship.setHierarchy(parameterList.get(numberCycles).getHierarchy());
                                        searchRelationship.setCardNumber(parameterList.get(numberCycles).getCardNumber());
                                        searchRelationship.setSize(parameterList.get(numberCycles).getSize());
                                        searList.add(searchRelationship);
                                        lowerRightY++;
                                    }
                                    searList.add(searchRelationship);
                                    numberCycles++;
                                }
                                break;
                            }

                        }
                        break;
                    }
                }

            }
        }
        return searList;
    }

}
