package com.example.gajz.transferrelationship.service;
import com.example.gajz.result.Result;
import com.example.gajz.transferrelationship.bean.excel.abcExcie;
import com.example.gajz.transferrelationship.bean.param.DiagramSpotParam;
import com.example.gajz.transferrelationship.bean.param.TransferAssociationParam;
import com.example.gajz.transferrelationship.bean.vo.SearchRelationshipVo;
import java.util.List;


/**
 * @author lenovo
 */
public interface TransferRelationshipService {


    /**
     * 边
     * @return
     */
    List<com.example.gajz.transferrelationship.bean.param.data> edge();


    /**
     * 点
     * @return
     */
    List diagramSpot(DiagramSpotParam diagramSpotParam);


    /**
     * 关系图搜索 单人转账关系（关联关系）接口
     * @param cardnumbe
     * @return
     */
    Result searchRelationship(String cardnumbe);


    /**
     * 转账关系图 信息搜索接口  查询某一个点的具体位置
     * @param id
     * @return
     */
    Result specificLocation(String id);

    /**
     * 清空关系图数据表
     */
    void emptyTransferRelationship();

    /**
     * excel数据导入数据库
     * @param eSerialsList
     */
    void insertTransferRelationship(List<abcExcie> eSerialsList);

    /**
     * 关系图 搜索接口
     * @param name
     * @return
     */
    Result pointSearch(String name);

    /**
     * 查询两人转账关系  (关系图) 接口
     * @param transferAssociationParam
     * @return
     */
    Result transferAssociation(TransferAssociationParam transferAssociationParam);

    /**
     * 关系图搜索  单人转账关系    转账信息信息查询接口
     * @return
     */
    Result personalTransferRelationship(int RedisId);

    /**
     * 查询两人转账关系  关系  (关系图) 接口
     * @return
     */
    Result trBetweenTwoPersons(List<SearchRelationshipVo> transferAssociationParam);

    /**
     * echarts 双人转账关系图 点  生成接口
     * @param transferAssociationParam
     * @return
     */
    Result echartsTransferAssociation(TransferAssociationParam transferAssociationParam);

    /**
     * echarts 双人转账关系图 关系 生成接口
     * @param transferAssociationParam
     * @return
     */
    Result echartsTrBetweenTwoPersons(List<SearchRelationshipVo> transferAssociationParam);
}
